// AUTOPILOT BY KK #2.60
// RELEASE VERSION 1.0
// You are free to use any part of the script, if you decide to publish it, I'd be grateful if you gave credits to me for it. I've really spent a load of time working // on this! :)

//-------------------------------------------------------------------------------------------------------------
//__ G L O B A L   U S E R   V A R I A B L E S __

global vTimestep is 0.0025.
global vAP_BoundPitchAngle is 15.	// autopilot never goes above or below a +-15deg pitch angle when trying to maintain an altitude / climbrate
global vAP_boundRollAngle is 40.	// max. / min. roll angle
global height is 8.0.			// radar altitude the kOS unit is reading when on ground with TO/LND pitch facing angle
global thrreverse is 1.			// 1 = vessel has thrust reverse, 0 = no: Action Group for thrust reversers must be AG4 !!
global vTakeOffSpeed is 60.		// start pitching up at this speed, shouldn't be too low to prevent holdpitch i runaway
global vTakeOffAngle is 8.		// maintain this pitch angle at takeoff to prevent tailstrike
global vAfterTakeOffSpeed is 150.	// maintain this speed after takeoff
global vAfterTakeOffAngle is 15.	// maintain this pitch angle after takeoff
global maxAltitude is 5000.		// max altitude the ap maintains (nav mode)
global glideslopetarget is -5.		// Glide slope angle which the plane will try to maintain during it's approach; MUST BE >vAP_BoundPitchAngle !!
global flaredistance is 5000.		// when to start flaring for landing; the smaller the distance the more rapid and inaccurate the flare manuever is !!
global minSpeed is 110.			// min speed to maintain (at landing), should be reached at 5km grounddistance to runway
global maxSpeed is 200.			// max speed the ap will maintain during approach
global approachdec is -2.0.		// deccalaration to maintain during approach
global appr_final_verticalspeed is -1.	// verticalspeed to maintain during final approach until touchdown
global gearDeployDistance is 7500.	// when to deploy gear for landing
global landingabort_allow is 1.		// allow landing abort if too low on the glideslope, not enough runway for braking left
global terrainRadar_running is false.




//-------------------------------------------------------------------------------------------------------------
//__ U S E R   I N T E R F A C E __

// FUNCTIONS FOR MAIN INTERFACE
function APmodeButton
{
	parameter button.	// GUI internal-name of button

	set button:toggle to true.
	set button:style:textcolor to rgb(0.8,0.8,0.8).
	set button:style:on:textcolor to rgb(0.1,0.9,0.1).
	set button:style:hover:textcolor to rgb(1.0,0.8,0.0).
	set button:style:hover_on:textcolor to rgb(1.0,0.8,0.0).
	set button:style:active:textcolor to rgb(0.1,0.9,0.1).
	set button:style:active_on:textcolor to rgb(0.1,0.9,0.1).
	set button:style:width to 46.
	set button:style:height to 30.
	set button:style:bg to "KK_ap/button_empty_std.png".
	set button:style:on:bg to "KK_ap/button_empty_pushed.png".
	set button:style:hover:bg to "KK_ap/button_empty_hover.png".
	set button:style:hover_on:bg to "KK_ap/button_empty_hover.png".
	set button:style:active:bg to "KK_ap/button_empty_pushed.png".
	set button:style:active_on:bg to "KK_ap/button_empty_pushed.png".
}


clearscreen.
clearguis().
switch to 0.
run once database.

set exit to false.	// variable to start / end autopilot and gui
set interface to gui(0).	// name of our gui
set interface:x to 20.	// start position:x
set interface:y to 50.	// start position:y
set interface:style:padding:h to 5. // padding = Spacing between the outside of the widget and its contents (text, etc.).
set interface:style:padding:v to 5.
set interface:style:bg to "KK_ap/gui_bg.png".
set vSettingsOpen to false.
set box_title to interface:addhbox().
set box_title:style:margin:bottom to 3.	// margin = Spacing between this and other widgets.

	// Image Autopilot Logo
	set l_logo to box_title:addlabel("").
	set l_logo:image to "KK_ap/logo2.png". 
	set l_logo:style:margin:right to 5.
	set l_logo:style:width to 34.

	// Textfield Vesselname
	set l_vesselname to box_title:addlabel("<b>" + ship:name + "</b>").
	set l_vesselname:style:width to 90.
	set l_vesselname:style:align to "left".
	set l_vesselname:style:fontsize to 15.
	set l_vesselname:style:margin:top to 13.
	set l_vesselname:style:textcolor to rgb(1.0,0.8,0.0).

	// Button Settings
	set b_settings to box_title:addbutton("Settings").
	set b_settings:style:width to 60.
	set b_settings:style:height to 30.	
	set b_settings:style:margin:top to 9.
	set b_settings:style:align to "center".
	set b_settings:onclick to 
	{ 
		if vSettingsOpen = true
		{
			interface_settings:hide().
			set vSettingsOpen to false.
		}
		else
		{
			interface_settings:show().
			set vSettingsOpen to true.
		}
	}.

	// Button Exit
	set b_exit to box_title:addbutton("").
	set b_exit:style:bg to "KK_ap/button_close_std.png".
	set b_exit:style:on:bg to "KK_ap/button_close_std.png".
	set b_exit:style:hover:bg to "KK_ap/button_close_hover.png".
	set b_exit:style:hover_on:bg to "KK_ap/button_close_hover.png".
	set b_exit:style:active:bg to "KK_ap/button_close_hover.png".
	set b_exit:style:active_on:bg to "KK_ap/button_close_std.png".
	set b_exit:style:width to 30.
	set b_exit:style:height to 30.	
	set b_exit:style:margin:top to 9.
	set b_exit:style:align to "right".
	set b_exit:onclick to { set running to false.}.

set box_main to interface:addhbox().
set box_main:style:padding:top to 10.
set box_main:style:padding:left to 10.
set box_main:style:padding:right to 10.
set box_main:style:padding:bottom to 10.

	// MODES
	set box_modes to box_main:addhbox(). // want to see a box containing all the mode toggles and parameter fields

		set box_modetoggles to box_modes:addvlayout(). // don't wanna see this
		set box_modetoggles:style:width to 55.

			set b_spd to box_modetoggles:addbutton("SPD").	// BUTTON SPEED
			APmodeButton(b_spd).
			set b_alt to box_modetoggles:addbutton("ALT").	// BUTTON ALTITUDE
			APmodeButton(b_alt).
			set b_hdg to box_modetoggles:addbutton("HDG").	// BUTTON HEADING
			APmodeButton(b_hdg).
			set b_pit to box_modetoggles:addbutton("PIT").	// BUTTON CLIMBRATE
			APmodeButton(b_pit).
			set b_tof to box_modetoggles:addbutton("T/O").	// BUTTON TAKEOFF
			APmodeButton(b_tof).
			set b_lnd to box_modetoggles:addbutton("LND").	// BUTTON LANDING
			APmodeButton(b_lnd).
			set b_nav to box_modetoggles:addbutton("NAV").	// BUTTON ROUTE
			APmodeButton(b_nav).
			set b_way to box_modetoggles:addbutton("WAY").	// BUTTON WAYPOINT
			APmodeButton(b_way).

		set box_modeparameters to box_modes:addvlayout(). // don't wanna see this
		set box_modeparameters:style:width to 100.

			set t_spd to box_modeparameters:addtextfield("0").
			set t_spd:style:width to 90.
			set t_spd:style:height to 25.
			set t_spd:style:margin:top to 6.
			set t_spd:style:textcolor to rgb(0.8,0.64,0). // text entered and confirmed
			set t_spd:style:hover:textcolor to rgb(0.6,0.48,0). // hover
			set t_spd:style:fontsize to 15.

			set t_alt to box_modeparameters:addtextfield("0").
			set t_alt:style:width to 90.
			set t_alt:style:height to 25.
			set t_alt:style:margin:top to 9.
			set t_alt:style:textcolor to rgb(0.8,0.64,0).. // text entered and confirmed
			set t_alt:style:hover:textcolor to rgb(0.6,0.48,0). // hover
			set t_alt:style:fontsize to 15.

			set t_hdg to box_modeparameters:addtextfield("0").
			set t_hdg:style:width to 90.
			set t_hdg:style:height to 25.
			set t_hdg:style:margin:top to 9.
			set t_hdg:style:textcolor to rgb(0.8,0.64,0). // text entered and confirmed
			set t_hdg:style:hover:textcolor to rgb(0.6,0.48,0). // hover
			set t_hdg:style:fontsize to 15.

			set t_pit to box_modeparameters:addtextfield("0").
			set t_pit:style:width to 90.
			set t_pit:style:height to 25.
			set t_pit:style:margin:top to 9.
			set t_pit:style:textcolor to rgb(0.8,0.64,0). // text entered and confirmed
			set t_pit:style:hover:textcolor to rgb(0.6,0.48,0). // hover
			set t_pit:style:fontsize to 15.
	
			// TAKEOFF TEXT
			set t_tof to box_modeparameters:addlabel("< Auto Select >").
			set t_tof:style:textcolor to rgb(0.8,0.8,0.8).
			set t_tof:style:fontsize to 13.
			set t_tof:style:margin:top to 12.
			set t_tof:style:margin:bottom to 12.
			
			// POPUPMENU LANDING
			set runwaynames to list().
			print "loading runways from database.".
			set a to 0. until a > runway_database:length-1
			{
				runwaynames:add(runway_database[a][0]).
				print "- added " + runway_database[a][0] + ".".
				set a to a + 1.
			}
			print "runway loading completed.".
			set pop_lnd to box_modeparameters:addpopupmenu().
			set pop_lnd:index to -1.
			set pop_lnd:options to runwaynames.
			set pop_lnd:style:width to 150.
			set pop_lnd:style:height to 25.
			set pop_lnd:style:margin:top to 9.
			set pop_lnd:style:textcolor to rgb(0.8,0.64,0).
			set pop_lnd:style:hover:textcolor to rgb(0.6,0.48,0).
			set pop_lnd:style:fontsize to 10.

			// POPUPMENU ROUTE
			set pop_nav to box_modeparameters:addpopupmenu().
			set routenames to list().
			print "loading routes from database.".
			set a to 0. until a > routes:length-1
			{
				routenames:add(routes[a][0]).
				print "- added " + routes[a][0] + ".".
				set a to a + 1.
			}
			set pop_nav:index to -1.
			print "route loading completed.".
			set pop_nav:options to routenames.
			set pop_nav:style:width to 150.
			set pop_nav:style:height to 25.
			set pop_nav:style:margin:top to 9.
			set pop_nav:style:textcolor to rgb(0.8,0.64,0).
			set pop_nav:style:hover:textcolor to rgb(0.6,0.48,0).
			set pop_nav:style:fontsize to 10.

			// POPUPMENU WAYPOINT
			set pop_way to box_modeparameters:addpopupmenu().
			set pop_way:index to -1.
			set waypointnames to list().
			print "loading waypoints from database.".
			set a to 0. until a > waypoint_database:length-1
			{
				waypointnames:add(waypoint_database[a][0]).
				print "- added " + waypoint_database[a][0] + ".".
				set a to a + 1.
			}
			print "waypoint loading completed.".
			set pop_way:options to waypointnames.
			set pop_way:style:width to 150.
			set pop_way:style:height to 25.
			set pop_way:style:margin:top to 9.
			set pop_way:style:textcolor to rgb(0.8,0.64,0).
			set pop_way:style:hover:textcolor to rgb(0.6,0.48,0).
			set pop_way:style:fontsize to 10.

		set box_modeparameters_units to box_modes:addvlayout(). // don't wanna see this

			set t_spd_unit to box_modeparameters_units:addlabel("[m/s]").
			set t_spd_unit:style:textcolor to rgb(0.7,0.7,0.7).
			set t_spd_unit:style:fontsize to 15.
			set t_spd_unit:style:margin:top to 6.

			set t_alt_unit to box_modeparameters_units:addlabel("[m]").
			set t_alt_unit:style:textcolor to rgb(0.7,0.7,0.7).
			set t_alt_unit:style:fontsize to 15.
			set t_alt_unit:style:margin:top to 13.
				
			set t_hdg_unit to box_modeparameters_units:addlabel("[deg]").
			set t_hdg_unit:style:textcolor to rgb(0.7,0.7,0.7).
			set t_hdg_unit:style:fontsize to 15.
			set t_hdg_unit:style:margin:top to 13.
		
			set t_pit_unit to box_modeparameters_units:addlabel("[m/min]").
			set t_pit_unit:style:textcolor to rgb(0.7,0.7,0.7).
			set t_pit_unit:style:fontsize to 15.
			set t_pit_unit:style:margin:top to 13.

interface:show().

// -------------------------------------------------------------------------------------
// SETTINGS WINDOW

// FUNCTIONS FOR SETTINGS WINDOW
function APsettingsLabel
{
	parameter label.
	set label:style:bg to "KK_ap/button_label.png".
	set label:style:textcolor to rgb(0.9,0.9,0.9).
	set label:style:fontsize to 10.
	set label:style:align to "center".
}

function APsettingsTextfield
{
	parameter textfield.
	set textfield:style:height to 14.
	set textfield:style:margin:top to 6.	
	set textfield:style:width to 50.
	set textfield:style:fontsize to 9.
}

set interface_settings to gui(0).	// name of our gui
set interface_settings:x to interface:x + 245.	// start position:x
set interface_settings:y to interface:y.	// start position:y
set interface_settings:style:padding:h to 5. // padding = Spacing between the outside of the widget and its contents (text, etc.).
set interface_settings:style:padding:v to 5.
set interface_settings:style:bg to "KK_ap/gui_bg.png".

set box_set_title to interface_settings:addhbox().
set box_set_title:style:margin:bottom to 3.
	set l_settings to box_set_title:addlabel("<b>Settings</b>").
	set l_settings:style:align to "center".
	set l_settings:style:fontsize to 15.
	set l_settings:style:textcolor to rgb(0.9,0.9,0.9).

set box_set_main to interface_settings:addvbox().

	set box_set_main_inner to box_set_main:addhbox().
	set box_set_main_inner:style:margin:top to 10.
	set box_set_main_inner:style:margin:bottom to 10.
	set box_set_main_inner:style:margin:left to 10.
	set box_set_main_inner:style:margin:right to 10.

		set box_set_labels to box_set_main_inner:addvlayout().
		set box_set_labels:style:width to 100.

			set l_set_height to box_set_labels:addlabel("height").	
			APsettingsLabel(l_set_height).
			set l_set_thrrev to box_set_labels:addlabel("thr rev.").	
			APsettingsLabel(l_set_thrrev).
			set l_set_minspeed to box_set_labels:addlabel("minSpeed").	
			APsettingsLabel(l_set_minspeed).
			set l_set_maxspeed to box_set_labels:addlabel("maxSpeed").	
			APsettingsLabel(l_set_maxspeed).
			set l_set_apprdecc to box_set_labels:addlabel("appr acc").	
			APsettingsLabel(l_set_apprdecc).
			set l_set_tospeed to box_set_labels:addlabel("T/O Speed").	
			APsettingsLabel(l_set_tospeed).
			set l_set_toangle to box_set_labels:addlabel("T/O Angle").	
			APsettingsLabel(l_set_toangle).
			set l_set_afttoangle to box_set_labels:addlabel("Aft. T/O Angle").	
			APsettingsLabel(l_set_afttoangle).
			set l_set_afttospeed to box_set_labels:addlabel("Aft. T/O Speed").	
			APsettingsLabel(l_set_afttospeed).
			set l_set_appitchlimit to box_set_labels:addlabel("AP Pitch Limit").	
			APsettingsLabel(l_set_appitchlimit).
			set l_set_aprolllimit to box_set_labels:addlabel("AP Roll Limit").	
			APsettingsLabel(l_set_aprolllimit).
			set l_set_gldslopetgt to box_set_labels:addlabel("AP Glideslope Tgt").	
			APsettingsLabel(l_set_gldslopetgt).
			set l_set_flaredistance to box_set_labels:addlabel("Flare Distance").
			APsettingsLabel(l_set_flaredistance).
			set l_set_allowlndabort to box_set_labels:addlabel("Allow lnd abort").
			APsettingsLabel(l_set_allowlndabort).
			set l_set_maxalt to box_set_labels:addlabel("AP Max Alt").
			APsettingsLabel(l_set_maxalt).
			set l_set_geardeploy to box_set_labels:addlabel("Gear Deploy Dist.").
			APsettingsLabel(l_set_geardeploy).
			

		set box_set_textfields to box_set_main_inner:addvlayout().
			set t_set_height to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_height).	
			set t_set_height:onconfirm to { parameter val. set height to val:tonumber(0).}.

			set t_set_thrrev to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_thrrev).	
			set t_set_thrrev:onconfirm to { parameter val. set thrreverse to val:tonumber(0).}.

			set t_set_minspeed to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_minspeed).
			set t_set_minspeed:onconfirm to { parameter val. set minspeed to val:tonumber(0).}.

			set t_set_maxspeed to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_maxspeed).
			set t_set_maxspeed:onconfirm to { parameter val. set maxspeed to val:tonumber(0).}.

			set t_set_apprdecc to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_apprdecc).
			set t_set_apprdecc:onconfirm to { parameter val. set approachdec to val:tonumber(0).}.

			set t_set_tospeed to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_tospeed).
			set t_set_tospeed:onconfirm to { parameter val. set vTakeOffSpeed to val:tonumber(0).}.

			set t_set_toangle to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_toangle).
			set t_set_toangle:onconfirm to { parameter val. set vTakeOffAngle to val:tonumber(0).}.	

			set t_set_afttoangle to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_afttoangle).
			set t_set_afttoangle:onconfirm to { parameter val. set vAfterTakeOffAngle to val:tonumber(0).}.

			set t_set_afttospeed to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_afttospeed).
			set t_set_afttospeed:onconfirm to { parameter val. set vAfterTakeOffSpeed to val:tonumber(0).}.	

			set t_set_appitchlimit to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_appitchlimit).
			set t_set_appitchlimit:onconfirm to { parameter val. set vAP_boundPitchAngle to val:tonumber(0).}.

			set t_set_aprolllimit to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_aprolllimit).
			set t_set_aprolllimit:onconfirm to { parameter val. set vAP_boundRollAngle to val:tonumber(0).}.

			set t_set_gldslopetgt to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_gldslopetgt).
			set t_set_gldslopetgt:onconfirm to { parameter val. set glideslopetarget to val:tonumber(0).}.

			set t_set_flaredistance to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_flaredistance).
			set t_set_flaredistance:onconfirm to { parameter val. set flaredistance to val:tonumber(0).}.

			set t_set_allowlndabort to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_allowlndabort).
			set t_set_allowlndabort:onconfirm to { parameter val. set landingabort_allow to val:tonumber(0).}.

			set t_set_maxalt to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_maxalt).
			set t_set_maxalt:onconfirm to { parameter val. set maxaltitude to val:tonumber(0).}.

			set t_set_geardeploy to box_set_textfields:addtextfield().
			APsettingsTextfield(t_set_geardeploy).
			set t_set_geardeploy:onconfirm to { parameter val. set gearDeployDistance to val:tonumber(0).}.

// -------------------------------------------------------------------------------------
// LANIDNG INFORMATION WINDOW


set interface_lnd to gui(245).	// name of our gui
set interface_lnd:x to interface:x.	// start position:x
set interface_lnd:y to interface:y + 355.	// start position:y
set interface_lnd:style:padding:h to 5. // padding = Spacing between the outside of the widget and its contents (text, etc.).
set interface_lnd:style:padding:v to 5.
set interface_lnd:style:bg to "KK_ap/gui_bg.png".
set interface_lnd:style:height to 245.

// JUST FOR GUI PURPOSES
set targetrunway to list("KSC Runway 09",latlng(-0.0486035631147535,-74.7242185628819),90.4).
set avg_eta to 278.

set box_lnd_main to interface_lnd:addvbox().
set box_lnd_main:style:width to 235.
set box_lnd_main:style:height to 235.

	set lnd_main_inner to box_lnd_main:addhbox().
	set lnd_main_inner:style:margin:top to 10.
	set lnd_main_inner:style:margin:bottom to 10.
	set lnd_main_inner:style:margin:left to 10.
	set lnd_main_inner:style:margin:right to 10.
	set lnd_main_inner:style:height to 215.
	set lnd_main_inner:style:width to 215.

		set lnd_mainscreen to lnd_main_inner:addvlayout().
		set lnd_mainscreen:style:bg to "KK_ap/Screen.png".
		set lnd_mainscreen:style:width to 215.	
		set lnd_mainscreen:style:height to 215.

			set lnd_mainscreen_label to lnd_mainscreen:addlabel("Landing Information").
			set lnd_mainscreen_label:style:align to "center".
			set lnd_mainscreen_label:style:fontsize to 15.
			set lnd_mainscreen_label:style:textcolor to rgb(1,1,1).

			set lnd_mainscreen_layoutlabels to lnd_mainscreen:addhlayout().

				set lnd_mainscreen_leftlabels to lnd_mainscreen_layoutlabels:addvlayout().
				set lnd_mainscreen_leftlabels:style:width to 70.

					set lnd_mainscreen_staticrnwname to lnd_mainscreen_leftlabels:addlabel("Runway").
					set lnd_mainscreen_staticrnwname:style:fontsize to 11.
					set lnd_mainscreen_staticrnwname:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_staticrnwname:style:height to 10.
					set lnd_mainscreen_staticrnwname:style:margin:left to 10.

					set lnd_mainscreen_statichdg to lnd_mainscreen_leftlabels:addlabel("Heading").
					set lnd_mainscreen_statichdg:style:fontsize to 11.
					set lnd_mainscreen_statichdg:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_statichdg:style:height to 10.
					set lnd_mainscreen_statichdg:style:margin:left to 10.

					set lnd_mainscreen_staticdistance to lnd_mainscreen_leftlabels:addlabel("Distance").
					set lnd_mainscreen_staticdistance:style:fontsize to 11.
					set lnd_mainscreen_staticdistance:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_staticdistance:style:height to 10.
					set lnd_mainscreen_staticdistance:style:margin:left to 10.

					set lnd_mainscreen_staticeta to lnd_mainscreen_leftlabels:addlabel("ETA").
					set lnd_mainscreen_staticeta:style:fontsize to 11.
					set lnd_mainscreen_staticeta:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_staticeta:style:height to 10.
					set lnd_mainscreen_staticeta:style:margin:left to 10.

					set lnd_mainscreen_staticalterror to lnd_mainscreen_leftlabels:addlabel("<b>ALT Error</b>").
					set lnd_mainscreen_staticalterror:style:fontsize to 11.
					set lnd_mainscreen_staticalterror:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_staticalterror:style:height to 10.
					set lnd_mainscreen_staticalterror:style:margin:left to 10.
					
					set lnd_mainscreen_statichdgerror to lnd_mainscreen_leftlabels:addlabel("<b>HDG Error</b>").
					set lnd_mainscreen_statichdgerror:style:fontsize to 11.
					set lnd_mainscreen_statichdgerror:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_statichdgerror:style:height to 10.
					set lnd_mainscreen_statichdgerror:style:margin:left to 10.

					set lnd_mainscreen_staticvs to lnd_mainscreen_leftlabels:addlabel("V/S").
					set lnd_mainscreen_staticvs:style:fontsize to 11.
					set lnd_mainscreen_staticvs:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_staticvs:style:height to 10.
					set lnd_mainscreen_staticvs:style:margin:left to 10.
				

				set lnd_mainscreen_rightlables to lnd_mainscreen_layoutlabels:addvlayout().

					set lnd_mainscreen_rnwname to lnd_mainscreen_rightlables:addlabel(targetrunway[0]).
					set lnd_mainscreen_rnwname:style:fontsize to 11.
					set lnd_mainscreen_rnwname:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_rnwname:style:height to 10.

					set lnd_mainscreen_hdg to lnd_mainscreen_rightlables:addlabel(targetrunway[2] + "deg").
					set lnd_mainscreen_hdg:style:fontsize to 11.
					set lnd_mainscreen_hdg:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_hdg:style:height to 10.

					set lnd_mainscreen_distance to lnd_mainscreen_rightlables:addlabel(round(targetrunway[1]:distance/1000,1) + "km").
					set lnd_mainscreen_distance:style:fontsize to 11.
					set lnd_mainscreen_distance:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_distance:style:height to 10.

					set lnd_mainscreen_eta to lnd_mainscreen_rightlables:addlabel(floor(avg_eta/60) + "min " + mod(avg_eta,60) + "s").
					set lnd_mainscreen_eta:style:fontsize to 11.
					set lnd_mainscreen_eta:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_eta:style:height to 10.

					set lnd_mainscreen_alterror to lnd_mainscreen_rightlables:addlabel("+100m").
					set lnd_mainscreen_alterror:style:fontsize to 11.
					set lnd_mainscreen_alterror:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_alterror:style:height to 10.

					set lnd_mainscreen_hdgerror to lnd_mainscreen_rightlables:addlabel("+5deg").
					set lnd_mainscreen_hdgerror:style:fontsize to 11.
					set lnd_mainscreen_hdgerror:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_hdgerror:style:height to 10.

					set lnd_mainscreen_vs to lnd_mainscreen_rightlables:addlabel("-5m/s").
					set lnd_mainscreen_vs:style:fontsize to 11.
					set lnd_mainscreen_vs:style:textcolor to rgb(1,1,1).
					set lnd_mainscreen_vs:style:height to 10.


// -------------------------------------------------------------------------------------
// ROUTE INFORMATION WINDOW


set interface_nav to gui(245).	// name of our gui
set interface_nav:x to interface:x.	// start position:x
set interface_nav:y to interface:y + 355.	// start position:y
set interface_nav:style:padding:h to 5. // padding = Spacing between the outside of the widget and its contents (text, etc.).
set interface_nav:style:padding:v to 5.
set interface_nav:style:bg to "KK_ap/gui_bg.png".
set interface_nav:style:height to 245.

// JUST FOR GUI PURPOSES
set gui_nav_demoroute to routes[0].

set box_nav_main to interface_nav:addvbox().
set box_nav_main:style:width to 235.
set box_nav_main:style:height to 235.

	set nav_main_inner to box_nav_main:addhbox().
	set nav_main_inner:style:margin:top to 10.
	set nav_main_inner:style:margin:bottom to 10.
	set nav_main_inner:style:margin:left to 10.
	set nav_main_inner:style:margin:right to 10.
	set nav_main_inner:style:height to 215.
	set nav_main_inner:style:width to 215.

		set nav_mainscreen to nav_main_inner:addvlayout().
		set nav_mainscreen:style:bg to "KK_ap/Screen.png".
		set nav_mainscreen:style:width to 215.	
		set nav_mainscreen:style:height to 215.

			set nav_mainscreen_label to nav_mainscreen:addlabel("Route Information").
			set nav_mainscreen_label:style:align to "center".
			set nav_mainscreen_label:style:fontsize to 15.
			set nav_mainscreen_label:style:textcolor to rgb(1,1,1).

			set nav_mainscreen_layoutlabels to nav_mainscreen:addhlayout().

				set nav_mainscreen_leftlabels to nav_mainscreen_layoutlabels:addvlayout().
				set nav_mainscreen_leftlabels:style:width to 70.

					set nav_mainscreen_staticroutestart to nav_mainscreen_leftlabels:addlabel("Route").
					set nav_mainscreen_staticroutestart:style:fontsize to 11.
					set nav_mainscreen_staticroutestart:style:textcolor to rgb(1,1,1).
					set nav_mainscreen_staticroutestart:style:height to 10.
					set nav_mainscreen_staticroutestart:style:margin:left to 10.

					set nav_mainscreen_staticdistance to nav_mainscreen_leftlabels:addlabel("Distance").
					set nav_mainscreen_staticdistance:style:fontsize to 11.
					set nav_mainscreen_staticdistance:style:textcolor to rgb(1,1,1).
					set nav_mainscreen_staticdistance:style:height to 10.
					set nav_mainscreen_staticdistance:style:margin:left to 10.

					set nav_mainscreen_statictime to nav_mainscreen_leftlabels:addlabel("Flight Time").
					set nav_mainscreen_statictime:style:fontsize to 11.
					set nav_mainscreen_statictime:style:textcolor to rgb(1,1,1).
					set nav_mainscreen_statictime:style:height to 10.
					set nav_mainscreen_statictime:style:margin:left to 10.				

				set nav_mainscreen_rightlables to nav_mainscreen_layoutlabels:addvlayout().

					set nav_mainscreen_routestart to nav_mainscreen_rightlables:addlabel(gui_nav_demoroute[0]).
					set nav_mainscreen_routestart:style:fontsize to 11.
					set nav_mainscreen_routestart:style:textcolor to rgb(1,1,1).
					set nav_mainscreen_routestart:style:height to 10.

					set nav_mainscreen_distance to nav_mainscreen_rightlables:addlabel("684km").
					set nav_mainscreen_distance:style:fontsize to 11.
					set nav_mainscreen_distance:style:textcolor to rgb(1,1,1).
					set nav_mainscreen_distance:style:height to 10.

					set nav_mainscreen_time to nav_mainscreen_rightlables:addlabel("58min").
					set nav_mainscreen_time:style:fontsize to 11.
					set nav_mainscreen_time:style:textcolor to rgb(1,1,1).
					set nav_mainscreen_time:style:height to 10.



// -------------------------------------------------------------------------------------
// TERRAIN RADAR WINDOW

// FUNCTIONS FOR TERRAIN RADAR WINDOW
function APterrDot
{
	parameter d.
	set d:style:fontsize to dot_fontsize.
	set d:style:textcolor to rgb(1,1,1).
	set d:style:height to dot_height.
	set d:style:width to dot_width.
}

function APallDotsStd
{
	clearscreen.
	print "Total of " + (terrAlt_mainscreen_layoutlabels:widgets:length+1) + " lines".
	local i is 0.
	until i >= terrAlt_mainscreen_layoutlabels:widgets:length	// lines (dotrows)
	{
		local line is terrAlt_mainscreen_layoutlabels:widgets[i].
		print "- dotrow" + (i+1).	// i + 1 because we started dotrow labels at 1, not 0
		print "- Total of " + (line:widgets:length) + " dots".
		local j is 0.
		until j >= line:widgets:length
		{
			local dot is line:widgets[j].
			print "  - dot" + (j+1). // j + 1 because we started dots at 1, not 0
			APterrDot(dot).
			set j to j + 1.
		}
		set i to i + 1.
	}
}

set interface_terrAlt to gui(245).	// name of our gui
set interface_terrAlt:x to interface:x.	// start position:x
set interface_terrAlt:y to interface:y + 355.	// start position:y
set interface_terrAlt:style:padding:h to 5. // padding = Spacing between the outside of the widget and its contents (text, etc.).
set interface_terrAlt:style:padding:v to 5.
set interface_terrAlt:style:bg to "KK_ap/gui_bg.png".
set interface_terrAlt:style:height to 245.


set box_terrAlt_main to interface_terrAlt:addvbox().
set box_terrAlt_main:style:width to 235.
set box_terrAlt_main:style:height to 235.

	set terrAlt_main_inner to box_terrAlt_main:addhbox().
	set terrAlt_main_inner:style:margin:top to 10.
	set terrAlt_main_inner:style:margin:bottom to 10.
	set terrAlt_main_inner:style:margin:left to 10.
	set terrAlt_main_inner:style:margin:right to 10.
	set terrAlt_main_inner:style:height to 215.
	set terrAlt_main_inner:style:width to 215.

		set terrAlt_mainscreen to terrAlt_main_inner:addvlayout().
		set terrAlt_mainscreen:style:bg to "KK_ap/Screen.png".
		set terrAlt_mainscreen:style:width to 215.	
		set terrAlt_mainscreen:style:height to 215.

			set terrAlt_mainscreen_label to terrAlt_mainscreen:addlabel("Terrain Radar").
			set terrAlt_mainscreen_label:style:align to "center".
			set terrAlt_mainscreen_label:style:fontsize to 15.
			set terrAlt_mainscreen_label:style:textcolor to rgb(1,1,1).

			set terrAlt_mainscreen_layoutlabels to terrAlt_mainscreen:addvlayout().

				local dot_symbol is ".".
				local dot_fontsize is 100.
				local dot_height is 2.
				local dot_width is 5.

				set terrAlt_mainscreen_dotrow1 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0101 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0101:style:margin:left to 25.
					set terrAlt_mainscreen_0102 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0103 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0104 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0105 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0106 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0107 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0108 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0109 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0110 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0111 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0112 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0113 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).
					set terrAlt_mainscreen_0114 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol)..
					set terrAlt_mainscreen_0115 to terrAlt_mainscreen_dotrow1:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow2 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0201 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0201:style:margin:left to 25.
					set terrAlt_mainscreen_0202 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0203 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0204 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0205 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0206 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0207 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0208 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0209 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0210 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0211 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0212 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0213 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0214 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).
					set terrAlt_mainscreen_0215 to terrAlt_mainscreen_dotrow2:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow3 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0301 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0301:style:margin:left to 25.
					set terrAlt_mainscreen_0302 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0303 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0304 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0305 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0306 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0307 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0308 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0309 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0310 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0311 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0312 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0313 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0314 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).
					set terrAlt_mainscreen_0315 to terrAlt_mainscreen_dotrow3:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow4 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0401 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0401:style:margin:left to 25.
					set terrAlt_mainscreen_0402 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0403 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0404 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0405 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0406 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0407 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0408 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0409 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0410 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0411 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0412 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0413 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0414 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).
					set terrAlt_mainscreen_0415 to terrAlt_mainscreen_dotrow4:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow5 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0501 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0501:style:margin:left to 25.
					set terrAlt_mainscreen_0502 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0503 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0504 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0505 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0506 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0507 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0508 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0509 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0510 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0511 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0512 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0513 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0514 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).
					set terrAlt_mainscreen_0515 to terrAlt_mainscreen_dotrow5:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow6 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0601 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0601:style:margin:left to 25.
					set terrAlt_mainscreen_0602 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0603 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0604 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0605 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0606 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0607 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0608 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0609 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0610 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0611 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0612 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0613 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0614 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).
					set terrAlt_mainscreen_0615 to terrAlt_mainscreen_dotrow6:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow7 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0701 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0701:style:margin:left to 25.
					set terrAlt_mainscreen_0702 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0703 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0704 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0705 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0706 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0707 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0708 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0709 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0710 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0711 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0712 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0713 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0714 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).
					set terrAlt_mainscreen_0715 to terrAlt_mainscreen_dotrow7:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow8 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0801 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0801:style:margin:left to 25.
					set terrAlt_mainscreen_0802 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0803 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0804 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0805 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0806 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0807 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0808 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0809 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0810 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0811 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0812 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0813 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0814 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).
					set terrAlt_mainscreen_0815 to terrAlt_mainscreen_dotrow8:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow9 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_0901 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0901:style:margin:left to 25.
					set terrAlt_mainscreen_0902 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0903 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0904 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0905 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0906 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0907 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0908 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0909 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0910 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0911 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0912 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0913 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0914 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).
					set terrAlt_mainscreen_0915 to terrAlt_mainscreen_dotrow9:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow10 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_1001 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1001:style:margin:left to 25.
					set terrAlt_mainscreen_1002 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1003 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1004 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1005 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1006 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1007 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1008 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1009 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1010 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1011 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1012 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1013 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1014 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).
					set terrAlt_mainscreen_1015 to terrAlt_mainscreen_dotrow10:addlabel(dot_symbol).

				set terrAlt_mainscreen_dotrow11 to terrAlt_mainscreen_layoutlabels:addhlayout().

					set terrAlt_mainscreen_1101 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1101:style:margin:left to 25.
					set terrAlt_mainscreen_1102 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1103 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1104 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1105 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1106 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1107 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1108 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1109 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1110 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1111 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1112 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1113 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1114 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).
					set terrAlt_mainscreen_1115 to terrAlt_mainscreen_dotrow11:addlabel(dot_symbol).

if terrainRadar_running = true {interface_terrAlt:show().}
APallDotsStd().


//-------------------------------------------------------------------------------------------------------------
//__ F U N C T I O N S __

// Determines and calculates all the required values for the AP to work
set deltaT to 0.
set last_airspeed to 0.
set last_vPitch to 0.
set last_vFacingPitch to 0.
set last_vAngleOfAttack to 0.
set last_vFacingHeading to 0.
set last_vFacingRoll to 0.
set last_verticalspeed to 0.
set last_liquidfuel to 0.
set last_vVelHeading to 0.
set last_latitude to 0.
set last_longitude to 0.
set last_altitude to 0.

set last_time to time:seconds.
set deltaT to 1.

set acceleration_settime to 0.
set vPitchRate_settime to 0.
set vFacingPitch_settime to 0.
set vAngleOfAttack_settime to 0.
set vFacingHeading_settime to 0.
set vFacingRoll_settime to 0.
set vVerticalSpeed_settime to 0.
set vLqf_settime to 0.
set vVelHeading_settime to 0.
function INPUT
{
	local t0 is time:seconds.

	global vAcceleration is (airspeed - last_airspeed) / (time:seconds - acceleration_settime).
	set acceleration_settime to time:seconds.
	global vPitch is arcsin( verticalspeed / airspeed ).
	global vPitchRate is (vPitch - last_vPitch) / (time:seconds - vPitchRate_settime).
	set vPitchRate_settime to time:seconds.
	global vFacingPitch is 90 - vectorangle( up:forevector, facing:forevector ).	// DEG
	global vFacingPitchRate is (vFacingPitch - last_vFacingPitch) / (time:seconds - vFacingPitch_settime).
	set vFacingPitch_settime to time:seconds.
	global vAngleOfAttack is vFacingPitch - vPitch.
	global vAngleOfAttackRate is (vAngleOfAttack - last_vAngleOfAttack) / (time:seconds - vAngleOfAttack_settime).
	set vAngleOfAttack_settime to time:seconds.
	global vFacingHeading is mod(360 - latlng(90,0):bearing,360).
	global vFacingHeadingRate is (vFacingHeading - last_vFacingHeading) / (time:seconds - vFacingHeading_settime).
	set vFacingHeading_settime to time:seconds.
	if round(vFacingHeadingRate,1) = 0 { global vTurnRadius is 0. global vTurnAcceleration is 0.}
	else { global vTurnRadius is airspeed * (360 / abs(vFacingHeadingRate)) / 2 * constant:pi / 8. global vTurnAcceleration is airspeed^2 / vTurnRadius.}
	global vFacingRoll is arctan2( ship:facing:upvector:normalized * vxcl( vxcl( ship:facing:vector,ship:up:vector ):normalized,vcrs( vxcl( ship:facing:vector,ship:up:vector ):normalized,ship:facing:vector ) ):normalized, ship:facing:upvector:normalized * vxcl( ship:facing:vector,ship:up:vector ):normalized:normalized ).
	global vFacingRollRate is (vFacingRoll - last_vFacingRoll) / (time:seconds - vFacingRoll_settime).
	set vFacingRoll_settime to time:seconds.
	global vVerticalSpeedRate is (verticalspeed - last_verticalspeed) / (time:seconds - vVerticalSpeed_settime).
	set vVerticalSpeed_settime to time:seconds.
	global vGroundSpeed is abs((airspeed^2-abs(verticalspeed)^2)^0.5).	// m/s
	global vLqfConsumption is (last_liquidfuel - ship:liquidfuel) / (time:seconds - vLqf_settime).
	set vLqf_settime to time:seconds.
	if vLqfConsumption = 0 { set vLqfConsumption to -1.}
	global vVelHeading is getVelHeading().
	global vVelHeadingRate is (vVelHeading - last_vVelHeading) / (time:seconds - vVelHeading_settime).
	set vVelHeading_settime to time:seconds.
	global dGeoLat is (latitude - last_latitude) / deltaT.
	global dGeoLng is (longitude - last_longitude) / deltaT.

	set last_airspeed to airspeed.
	set last_vPitch to vPitch.
	set last_vFacingPitch to vFacingPitch.
	set last_vAngleOfAttack to vAngleOfAttack.
	set last_vFacingHeading to vFacingHeading.
	set last_vFacingRoll to vFacingRoll.
	set last_verticalspeed to verticalspeed.
	set last_liquidfuel to ship:liquidfuel.
	set last_vVelHeading to vVelHeading.
	set last_latitude to latitude.
	set last_longitude to longitude.

	//print "INPUT Update Time: " + round(time:seconds-t0,3) + "s     " at (0,2).
}

function getVelHeading	// found on reddit
{
	local north_ is SHIP:NORTH:VECTOR.  
	local up_ is SHIP:UP:VECTOR.  
	local east_ is VECTORCROSSPRODUCT(up_, north_):NORMALIZED.  
	local northVel_ is VECTORDOTPRODUCT(SHIP:VELOCITY:SURFACE, north_).  
	local eastVel_ is VECTORDOTPRODUCT(SHIP:VELOCITY:SURFACE, east_).  
	local velHeading_ is ARCTAN2(eastVel_, northVel_). //-180 to 180 deg. 0 deg = north.  
	local velHeading2_ is MOD(velHeading_ + 360, 360). //0 to 360 deg. 0 deg = north. 
	
	return velHeading2_. 	
}

set vMaintainClimbRate_totalerror to 0.
set vMaintainClimbRate_lastFacingPitchRate to 0.
set last_error to 0.
set vMaintainClimbRate_OscDamper to 1.0.
set vMaintainClimbRate_OscDamper_lastSpeed to 0.
set vMaintainClimbRate_OscDamper_lastValue to vMaintainClimbRate_OscDamper.
// Maintains a given pitch velocity vector
function MAINTAINVP
{
	parameter pTarget.	// target velocity pitch [deg]

	local t0 is time:seconds.
	IF vPitch >= 2 and alt:radar-height > 500 { SET modifier to min(max(airspeed / (minSpeed*1.25),0.1),1).}
	ELSE set modifier to 1.
	local error is pTarget * modifier - vPitch.
	set t_pit:text to (round(sin(pTarget * modifier)*airspeed*60/100)*100):tostring().

	local AoA_multiplier is 1.0.
	local Pitch_multiplier is 1.0.

	local vAoA_p is vAngleOfAttack * (-0.05) * AoA_multiplier.
	local vAOA_d to vAngleOfAttackRate * (-0.01) * AoA_multiplier.

	local vPitch_p is error * 0.02 * Pitch_multiplier.
	local vPitch_d is vPitchRate * (-0.002) * Pitch_multiplier.
	local vPitch_i is vMaintainClimbRate_totalerror * 0.00005 * Pitch_multiplier.

	//print "AoA: " + round(vAngleOfAttack,1) + "     " at (0,8).
	//print "AoA Rate: " + round(vAngleOfAttackRate,1) + "     " at (0,9).

	// + ERROR: We need to pitch up! + vPITCHRATE: Pitching up!
	local base is 0.4. // 0.4
	local bound is 0.01. // 0.025
	if vPitchRate <= error * (base-bound)
	{
		set vMaintainClimbRate_totalerror to vMaintainClimbRate_totalerror + min(max(24000 * abs(vPitch_p) * vMaintainClimbRate_OscDamper,-1600),1600).	// 8000
	}
	else if vPitchRate >= error * (base+bound)
	{
		set vMaintainClimbRate_totalerror to vMaintainClimbRate_totalerror - min(max(24000 * abs(vPitch_p) * vMaintainClimbRate_OscDamper,-1600),1600).
	}


	if vFacingPitchRate > 0.5 and vMaintainClimbRate_lastFacingPitchRate < -0.5 or vFacingPitchRate < - 0.5 and vMaintainClimbRate_lastFacingPitchRate > 0.5
	{
		set vMaintainClimbRate_OscDamper to max(vMaintainClimbRate_OscDamper - 0.04,0.05).
		set vMaintainClimbRate_OscDamper_lastSpeed to airspeed.
		set vMaintainClimbRate_OscDamper_lastValue to vMaintainClimbRate_OscDamper.
	}
	else
	{
		if vMaintainClimbRate_OscDamper_lastSpeed > 5
		{
			//set vMaintainClimbRate_OscDamper to max(min(vMaintainClimbRate_OscDamper + 0.0005,1.25*(vMaintainClimbRate_OscDamper_lastSpeed / max(airspeed,1) * vMaintainClimbRate_oscDamper_lastValue)),0.05).
			set vMaintainClimbRate_OscDamper to min(vMaintainClimbRate_OscDamper + 0.001,1).
		}
	}

	local out is (vPitch_p*vMaintainClimbRate_OscDamper+vPitch_d*vMaintainClimbRate_OscDamper+vPitch_i)+(vAoA_p+vAoA_d)*vMaintainClimbRate_OscDamper.

	set vMainTainClimbRate_totalerror to min(max(vMainTainClimbRate_totalerror + error,-20000),20000).
	set vMaintainClimbRate_lastFacingPitchRate to vFacingPitchRate.
	set last_error to error.

	print "Pitch Osc Damper: " + round(vMaintainClimbRate_OscDamper,2) + "     " at (0,25).

	if SAS = 0 { set ship:control:pitch to out.}
	else set ship:control:neutralize to true.

	//print "MAINTAINCLIMBRATE Update Time: " + round(time:seconds - t0,3) + "s     " at (0,3).
}

set vMaintainClimbRate_OscFrequency to 0.
set vMaintainClimbRate_OscCount to 0.
// Maintains a given facing pitch velocity vector
function MAINTAINFP
{
	parameter pTarget.	// target pitch facing [deg]
	local error is pTarget - vFacingPitch.

	local AoA_multiplier is 0.0.
	local Pitch_multiplier is 1.0.
	local vAoA_p is vAngleOfAttack * (-0.02) * AoA_multiplier.
	local vAOA_d to vAngleOfAttackRate * (-0.002) * AoA_multiplier.
	local vPitch_p is error * 0.02 * Pitch_multiplier.
	local vPitch_d is vFacingPitchRate * (-0.002) * Pitch_multiplier.
	local vPitch_i is vMaintainClimbRate_totalerror * 0.00005.
	
	// + ERROR: We need to pitch up! + vPITCHRATE: Pitching up!
	local base is 0.4.
	local bound is 0.01.
	if vPitchRate <= error * (base-bound)
	{
		set vMaintainClimbRate_totalerror to vMaintainClimbRate_totalerror + min(max(24000 * abs(vPitch_p),-400),400).	// 8000
	}
	else if vPitchRate >= error * (base+bound)
	{
		set vMaintainClimbRate_totalerror to vMaintainClimbRate_totalerror - min(max(24000 * abs(vPitch_p),-400),400).
	}

	if vFacingPitchRate > 1.0 and vMaintainClimbRate_lastFacingPitchRate < -1.0 or vFacingPitchRate < -1.0 and vMaintainClimbRate_lastFacingPitchRate > 1.0
	{
		set vMaintainClimbRate_OscCount to vMaintainClimbRate_OscCount + 1.	
	}
	set vMaintainClimbRate_OscFrequency to vMaintainClimbRate_OscCount / (time:seconds - starttime).
	set vMaintainClimbRate_OscDamper to 1 / (vMaintainCLimbRate_OscFrequency+1).

	local vPitchOut is min(max(vPitch_p + vPitch_d + vPitch_i,-2),2).
	local vAoAOut is (vAoA_p + vAoA_d) * vMaintainClimbRate_OscDamper.
	local out is vPitchOut + vAoAOut.

	set vMainTainClimbRate_totalerror to min(max(vMainTainClimbRate_totalerror + error,-20000),20000).
	set vMaintainClimbRate_lastFacingPitchRate to vFacingPitchRate.

	if SAS = 0 { set ship:control:pitch to out.}
	else set ship:control:neutralize to true.
}

// Outputs a pitch angle for MAINTAINVP to hold to reach the target altitude
function HOLDALTITUDE
{
	parameter pTarget.	// in m above sea level
	local out is min(max(arctan((pTarget - altitude) * 0.1/vGroundSpeed),-vAP_BoundPitchAngle),vAP_BoundPitchAngle).

	MAINTAINVP(out).
}


set last_R_rateError to 0.
set last_R_rateError_settime to 0.
set rollP_total to 0.
//set last_vFacingRollRate to 0.
set last_degError to 0.
set roll_oscDamper to 1.0.
set roll_oscDamper_lastSpeed to 0.
set roll_oscDamper_lastValue to roll_oscDamper.
set holdhdg_p_total to 0.
function MAINTAINHEADING
{
	parameter pTarget.	// Heading target [deg]
	local hdg_error is pTarget - vVelHeading.
	if hdg_error > 180
	{
		set hdg_error to hdg_error - 360.
	}
	else if hdg_error < -180
	{
		set hdg_error to hdg_error + 360.
	}
	local hdg_p is hdg_error * 5.0.
	local hdg_d is vVelHeadingRate * (-5.0).
	local hdg_i is holdhdg_p_total * 0.01.
	local hdg_angle is max(min(hdg_p + hdg_d + hdg_i,vAP_boundRollAngle),-vAP_boundRollAngle).
	if vVelHeadingRate > -0.2 and vVelHeadingRate < 0.2 and abs(hdg_angle-vFacingRoll) < 5
	{
		set holdhdg_p_total to holdhdg_p_total + hdg_p.
	}
	set holdhdg_p_total to holdhdg_p_total * 0.998.
	local hdg_rollTarget is hdg_angle.


	local pTarget_rollMultiply is max(min((alt:radar-height) * 0.05,1.0),0.0).
	local yawMultiply is 1 - pTarget_rollMultiply.

	local R_degError is hdg_rollTarget * pTarget_rollMultiply - vFacingRoll.
	local R_targetRollRate is R_degError * 1.0.
	local R_rateError is R_targetRollRate - vFacingRollRate.
	if (time:seconds - last_R_rateError_settime) > 0
	{
		set R_rateError_change to (R_rateError - last_R_rateError) / (time:seconds - last_R_rateError_settime).
	}
	else
	{
		set R_rateError_change to 0.
	}
	local roll_p is R_rateError * 0.02.
	local roll_d is R_rateError_change * 0.0005 * 0.0.
	local roll_i is rollP_total * 0.01.
	// I
	if vFacingRollRate > -1 and vFacingRollRate < 1
	{
		set rollP_total to max(min(rollP_total + roll_p,100),-100).
	}
	if R_degError > -0.2 and R_degError < 0.2
	{
		set rollP_total to rollP_total * 0.999.
	}
	// OSC DAMPER
	//if vFacingRollRate > 0.4 and last_vFacingRollRate < -0.4 or vFacingRollRate < -0.4 and last_vFacingRollRate > 0.4
	if R_rateError > 0.5 and last_R_rateError < -0.5 or R_rateError < -0.5 and last_R_rateError > 0.5
	{
		set roll_oscDamper to max(roll_oscDamper - 0.04,0.025).
		set roll_oscDamper_lastSpeed to airspeed.
		set roll_oscDamper_lastValue to roll_oscDamper.
	}
	else
	{
		if roll_oscDamper_lastSpeed > 5
		{
			set roll_oscDamper to min(roll_oscDamper + 0.00025,1).
		}
	}
	
	print "Roll Osc Damper: " + round(roll_oscDamper,3) + "     " at (0,26).


	SET roll_output to roll_p * roll_oscDamper + roll_d * roll_oscDamper + roll_i.


	set last_R_rateError to R_rateError.
	set last_R_rateError_settime to time:seconds.
	set last_R_degError to R_degError.
	

	local Y_error is pTarget - vVelHeading.
	if Y_error > 180
	{
		set Y_error to Y_error - 360.
	}
	else if Y_error < -180
	{
		set Y_error to Y_error + 360.
	}
	local Y_p is Y_error * 0.04.
	local Y_d is (-0.0125) * vVelHeadingRate.
	local Y_out is max(min(Y_p + Y_d,1),-1) * yawMultiply.
	
	
	

	if sas = 0 
	{ 
		set ship:control:roll to roll_output.
		set ship:control:yaw to (Y_out + 2*ship:control:pilotyaw) * 2.0.	// + is r, - is l
		set ship:control:wheelsteer to (Y_out + 2*ship:control:pilotyaw) * (-0.5).	// + is l, - is r
	}
	if sas = 1 { set ship:control:neutralize to true.}
}


// RETURNS pitch angle for the plane to maintain
// NOTE that this function already uses runwayterrainheight and plane height, no need to add that in the offset parameters!
set autoland_glideslope_lastError_settime to 0.
set altitudeError_total to 0.
function autoland_glideslope
{
	parameter pDeg.	// Glideslope target in degrees (sign "-" = descending, sign "+" = ascending)
	parameter pO_x.	// Ground distance from runway in m (sign "+" = "behind" the runway (from plane), sign "+" = "before" runway (from plane))
	parameter pO_y.	// Altitude offset from runway in m (sign "-" = above runway, sign "-" = below runway

	local x is 0.
	local glideslopeAltitude is -tan(pDeg) * (max(grounddistance+x - pO_x,0)) + runwaypos:terrainheight + height + pO_y.
	global altitudeError is glideslopeAltitude - altitude.	// global to show it on the screen (in the textfield)
	local altitudeError_p is altitudeError * 0.04. // 0.04
	local altitudeError_d is (altitudeError - autoland_glideslope_lastError) / (time:seconds - autoland_glideslope_lastError_settime) * 0.05.
	local altitudeError_i is altitudeError_total * 0.004.
	set autoland_glideslope_lastError to altitudeError.
	set autoland_glideslope_lastError_settime to time:seconds.
	if altitudeError > - 20 and altitudeError < 20 and grounddistance < flareDistance/2
	{
		set altitudeError_total to max(min(altitudeError_total + altitudeError,1/0.005),-1/0.0005).
	}
	if altitudeError > -1 and altitudeError < 1
	{
		set altitudeError_total to altitudeError_total * 0.99.
	}
	if altitudeError > 2 and altitudeError_total < 0
	{
		set altitudeError_total to altitudeError_total * 0.5.
	}

	local autoland_glideslope_out is altitudeError_p + altitudeError_d + altitudeError_i.
	local angle_out is max(min(pDeg + min(max(autoland_glideslope_out,-25),25),vAP_BoundPitchAngle),-vAP_boundPitchAngle).

	return angle_out.
}



set lnd_touchdowntime to 0.
set lnd_touchdowntime_set to false.
set landingabort to false.
set runway_reached to false.
function autoland
{
	parameter p.
	SET targetrunway to runway_database[p].
	SET p2 to p + (-1)^p.
	SET counterrunway to runway_database[p2].
	
	SET runwayheading to targetrunway[2].
	SET runwaypos to targetrunway[1].

	if autoland_targetmode = "wp"
	{
		set wp_centerline_offset to 0.25.
		set wp_centerline_lat to runwaypos:lat - cos(runwayheading) * wp_centerline_offset.
		set wp_centerline_lng to runwaypos:lng - sin(runwayheading) * wp_centerline_offset.
		set wp_centerline to latlng(wp_centerline_lat,wp_centerline_lng).

		set autoland_target_lat to wp_centerline_lat.
		set autoland_target_lng to wp_centerline_lng.

		if (wp_centerline:distance^2-altitude^2)^0.5 < 1000
		{
			set autoland_targetmode to "rnw".
		}
	}
	else if autoland_targetmode = "rnw"
	{
		set autoland_target_lat to runwaypos:lat.
		set autoland_target_lng to runwaypos:lng.
	}
	
	SET grounddistance to max(runwaypos:distance^2 - (altitude - runwaypos:terrainheight)^2,0.0001)^0.5.
	local grounddistance_settime is time:seconds.

	set dlat to latitude - autoland_target_lat.
	set dlng to longitude - autoland_target_lng.
	if dlng < 0 { set alpha to 90 - arctan(dlat / dlng).}	// alpha is the absolute heading the plane needs to fly to reach the runway
	else  { set alpha to 270 - arctan(dlat / dlng).}
	set beta to alpha-runwayheading.	// beta is the difference in heading between alpha and the runwayheading
	set headingtarget to alpha + beta.
	if headingtarget < 0 {set headingtarget to headingtarget + 360.}
	
	//set flareDistance to 5000. // Distance in m from runway where plane should start the flaring; 5000
	set appr_final_pitch to arcsin(appr_final_verticalspeed/max(airspeed,0.001)).
	set flare_multiplier to max(min(grounddistance/flareDistance,1.0),0.0).
	set lnd_glideslope to min(flare_multiplier*glideslopetarget,appr_final_pitch).
	set offsetFactor_x to (-1) * (-5/glideslopetarget)*(flareDistance/10).
	set lnd_offset_x to min((lnd_glideslope - appr_final_pitch) * offsetFactor_x,flareDistance/2).

	set targetangle to autoland_glideslope(lnd_glideslope,lnd_offset_x,0).

	print "flareDistance: " + round(flareDistance) + "     " at (0,5).
	print "offset X: " + round(lnd_offset_x) + "     " at (0,6).

	set distance_d to (lastdistance - grounddistance) / lag.
	set distance_eta to grounddistance / distance_d.	// min
	set avg_eta to grounddistance / ( (distance_d + airspeed + minSpeed) / 3).
	set lastdistance to grounddistance.
	set lastdistance_settime to time:seconds.
	print "distance_eta: " + round(distance_eta) + "     " at (0,27).

	local speed_established is 4000.	// distance from runway where touchdown velocity should be reached
	set appr_decTime to (airspeed-minSpeed) / abs(approachdec).
	set appr_dist to abs(approachdec)/2 * appr_decTime^2 + minSpeed * appr_decTime.
	set appr_decFactor to (appr_dist / max((grounddistance-speed_established),1)).
	if appr_decFactor > 0.95 and autoland_appr_decc = 0 { set autoland_appr_decc to 1.}
	if autoland_appr_decc = 1
	{
		set approachspeed to max(min(airspeed + 1/lag*appr_decFactor * approachdec,maxSpeed),minSpeed).
	}
	else set approachspeed to maxSpeed.
	

	if grounddistance < 100 and runway_reached = false
	{
		set runway_reached to true.
	}
	if (alt:radar-height) < 1 and autoland_mode <> "landed" and runway_reached = true
	{
		set autoland_mode to "landed".
		if thrreverse = 1
		{		
			ag4 on.	
			lock throttle to 1.
		}
		else
		{
			lock throttle to 0.
			brakes on.
		}
	}

	if autoland_mode = "landed"
	{
		set targetangle to -2.
		if lnd_touchdowntime_set = false
		{
			set lnd_touchdowntime to time:seconds.
			set lnd_touchdowntime_set to true.
		}
		if (time:seconds - lnd_touchdowntime) > 5
		{
			local stop_brakeTime is airspeed / abs(vAcceleration).
			local stop_distance is abs(vAcceleration)/2 * stop_brakeTime^2.
			local stop_timeToRunwayEnd is (2*counterrunway[1]:distance/abs(vAcceleration))^0.5.
			local final_speed is airspeed - abs(vAcceleration) * stop_timeToRunwayEnd.

			local acc_time is (minSpeed - airspeed) / 2.
			local acc_distance is 2/2 * acc_time^2.
			print "Brake distance: " + round(stop_distance) + "m     " at (0,30).
			print "Remaining Runway: " + round(counterrunway[1]:distance) + "m     " at (0,31).
			print "Diff: " + round(counterrunway[1]:distance - stop_distance) + "m     " at (0,32).
			print "final_speed: " + round(final_speed) + "m/s     " at (0,33).
			print "acc_distance: " + round(acc_distance) + "m     " at (0,34).
			if (counterrunway[1]:distance - stop_distance) < 0 and final_speed > 30 and (counterrunway[1]:distance - (2/2 * ((minSpeed - airspeed) / 2)^2)) > 0
			{
				set landingabort to true.
			}
		}

		MAINTAINHEADING(targetWP_hdg).
		if airspeed < 15
		{
			lock throttle to 0.
			brakes on.
			if airspeed < 5
			{
				if ag4 = true
				{
					ag4 off.
				}
			}
		}
		
	}
	

	if grounddistance < 750 and autoland_headingmode <> 1
	{
		set autoland_headingmode to 1.
	}


	set targetWP to list(counterrunway[0],counterrunway[1]).
	set targetWP_hdg to FLYTOWAYPOINT(targetWP).

	if autoland_mode <> "flare" and autoland_mode <> "landed"
	{
		AUTOTHROTTLE(approachspeed).
	}
	if autoland_headingmode = 0
	{
		MAINTAINHEADING(headingtarget).
	}
	else if autoland_headingmode = 1
	{
		MAINTAINHEADING(targetWP_hdg).
	}
	if grounddistance <= gearDeployDistance
	{
		if gear = false
		{
			toggle gear.
		}
	}
	
	// L A N D I N G   A B O R T   T R I G G E R S

	// Too low on the glideslope
	//local appr_altError_lowerBound is grounddistance^1.2* (0.002) - 2.
	//print round(altitudeError-appr_altError_lowerbound) + "m     "at (0,9).
	//if (altitudeError-appr_altError_lowerbound) > 0 and autoland_mode <> "landed" and grounddistance < 5000 and autoland_headingmode = 0
	if (altitude-height - targetrunway[1]:terrainheight) < 5 and altitudeError > 3 and vVerticalSpeedRate < -0.2 and autoland_mode <> "landed" and grounddistance < 1000 and runway_reached = false
	{
		set landingabort to true.
	}
	print "LANDINGABORT " at (0,10).
		print "Height: " at (0,11).
			print round(altitude-height-targetrunway[1]:terrainheight,1) + "   " at (20,11).
			if (altitude-height - targetrunway[1]:terrainheight) < 5
			{
				print "ABORT" at (30,11).
			}
			else print "       " at (30,11).

		print "vVerticalSpeedRate: " at (0,12).
			print round(vVerticalSpeedRate,1) + "     " at (20,12).
			if vVerticalSpeedRate < -0.2
			{
				print "ABORT " at (30,12).
			}
			else print "        " at (30,12).
		print "grounddistance: " at (0,13).
			print round(grounddistance) + "     " at (20,13).
			if grounddistance < 1000
			{
				print "ABORT" at (30,13).
			}
			else print "        " at (30,13).
		print "altitudeError: " at (0,14).
			print round(altitudeError,1) + "     " at (20,14).
			if altitudeError > 3
			{
				print "ABORT" AT (30,14).
			}
			else print "        "at (30,14).
		print "mode: " at (0,15).
			print autoland_mode + "     " at (20,15).
			if autoland_mode <> " landed"
			{
				print "ABORT" at (30,15).
			}
			else print "      " at (30,15).

		print "runway_reached: " at (0,16).
			print runway_reached + "     " at (20,16).
			if runway_reached = false
			{
				print "ABORT" at (30,16).
			}
			else print "       " at (30,16).
	// Missed touchdown point and flying above the runway
	if counterrunway[1]:distance < (2.5) * (airspeed/5)^2 and autoland_mode <> "landed"
	{
		set landingabort to true.
	}

	if landingabort = true and landingabort_allow = 1
	{
		autoland_abort().
	}

	// Show proper values in gui
	set t_spd:text to round(approachspeed):tostring().
	set t_hdg:text to round(headingtarget):tostring().
	set t_pit:text to ( round(sin(targetangle)*airspeed*60/100)*100 ):tostring().


	MAINTAINVP(targetangle).
	
	//logDescent().
}

set logDescent_lastLog to 0.
function logDescent
{
	if (time:seconds - logDescent_lastLog) > 1
	{
		log round(grounddistance/1000,2) + "," + round(altitude-height - targetrunway[1]:terrainheight) + "," + round(altitudeError,1) + "," + round(verticalspeed,1) + "," + round(vVerticalSpeedRate,1) to log_descent.txt.
		set logDescent_lastLog to time:seconds.
	}
}

function autoland_abort
{
	HUDTEXT("<AP> Aborting Landing", 3, 2, 18, red, false).	
	set b_lnd:pressed to false.
	set autoland_abort_hdgTarget to vVelHeading.

	if ag4 = true
	{
		ag4 off.
	}
	if brakes = true
	{
		brakes off.
	}
	set TO_runway to targetrunway.
	set TO_override to true.
	set mode_tof_allow to true.
	set TO_pitchTarget to 0.
	set TO_targetWP to counterrunway.
	set TO_targetWP_hdg to vVelHeading.
	set b_tof:pressed to true.
}

function TAKEOFF
{
	if alt:radar - height < 25 and TO_targetWP[1]:distance > 200
	{
		set TO_targetWP_hdg to FLYTOWAYPOINT(TO_targetWP).
	}


	if SAS = true
	{
		SAS off.
	}
	if availablethrust = 0
	{
		stage.
		wait 0.5.
	}
	if airspeed >= vTakeOffSpeed
	{
		if alt:radar - height < 25
		{
			MAINTAINFP(vTakeOffAngle * max( ((alt:radar-height) * 0.01 + 1),1 )).
		}
		else 
		{
			MAINTAINVP(vAfterTakeOffAngle).
		}
	}
	else
	{
		MAINTAINFP(TO_pitchTarget).	
	}
	if alt:radar - height > 50 and GEAR = true
	{
		GEAR off.
	}

	MAINTAINHEADING(TO_targetWP_hdg).
	AUTOTHROTTLE(vAfterTakeOffSpeed).

	// Show correct values in gui
	set t_spd:text to round(vAfterTakeOffSpeed):tostring().
	set t_hdg:text to round(TO_targetWP_hdg):tostring().
	set t_pit:text to (round( (sin(vAfterTakeOffAngle)*airspeed*60)/100 )*100):tostring().
}


function autothrottle
{
	parameter vtarget.
	SET p to (vtarget - airspeed) * 0.2.
	SET d to vAcceleration * 0.5.
	SET thr to min(max(p - d,0),1).
	if SAS = 0 { LOCK throttle to thr.}
	else unlock throttle.
}

function flytowaypoint
{
	parameter targetwaypoint.

	SET dlat to latitude - targetwaypoint[1]:lat.
	SET dlng to longitude - targetwaypoint[1]:lng.
	set wp_distance to max(targetwaypoint[1]:distance^2-(altitude-targetwaypoint[1]:terrainheight)^2,0.0001)^0.5.
	IF dlng < 0 { SET outputhdg to 90 - arctan(dlat / dlng).}
	ELSE  { SET outputhdg to 270 - arctan(dlat / dlng).}

	if wp_distance < 4000
	{
		set b_way:pressed to false.
		colourButton(b_hdg,0).
	}

	// Show value in gui
	set t_hdg:text to round(outputhdg):tostring().
	return outputhdg.
}

// function to find runway by it's name
function findRunwayByName
{
	parameter name.
	SET a to 0.
	UNTIL a > runway_database:length-1
	{
		IF name = runway_database[a][0]
		{
			return a.
		}
		SET a to a + 1.
	}	
}

// function to find route by it's name
function findRouteByName
{
	parameter name.
	set a to 0.
	set done to false.
	until done = true
	{
		if routes[a][0] = name
		{
			set done to true.
		}
		else
		{
			set a to a + 1.
		}
	}
	return a.
}
// function to find waypoint by it's name
function findWaypointByName
{
	parameter name.
	set a to 0.
	set done to false.
	until done = true
	{
		if waypoint_database[a][0] = name
		{
			set done to true.
		}
		else
		{
			set a to a + 1.
		}
	}
	return a.
}

// Finds the next best-suited runway to land on and returns its position in the runway_database list
function FINDRUNWAY
{
	set closestRnw to 0.
	set closestDist to runway_database[0][1]:distance.
	set i to 1.
	until i >= runway_database:length - 1
	{
		if runway_database[i][1]:distance < closestDist
		{
			set closestRnw to i.
			set closestDist to runway_database[i][1]:distance.
		}
		set i to i + 1.
	}
	return closestRnw.
}

// Checks if any suitable runway is near, if yes: 
// 	- Return true and set all variables required for takeoff
// - If no:
//	- Return false
function CHECKTAKEOFF
{
	local p is FINDRUNWAY().
	set TO_runway to runway_database[p].
	local p2 is p + (-1)^p.
	local targetRNW is runway_database[p2].
	set TO_targetWP to list(targetRNW[0],targetRNW[1]).

	if TO_runway[1]:distance < 300
	{
		set TO_headingTarget to mod(360 - latlng(90,0):bearing,360).
		set TO_pitchTarget to 90 - vectorangle( up:forevector, facing:forevector ).
		return true.	
	}
	else
	{
		return false.
	}
}

function flyroute
{
	parameter route.

	set navroute to route.
	SET dist_destination to max(route[1][route[1]:length-1][1]:distance^2-(altitude-route[1][route[1]:length-1][1]:terrainheight)^2,0.0001)^0.5.

	set nav_distance_d to (nav_lastdistance - dist_destination) / lag.
	set nav_distance_eta to dist_destination / nav_distance_d.	// s
	set nav_lastdistance to dist_destination.
	set nav_lastdistance_settime to time:seconds.

	IF mode_nav_doTakeoff = true
	{
		set b_tof:pressed to true.
		set mode_nav_doTakeoff to false.
	}

	ELSE IF route[1]:length > 1 AND flyroute_a < route[1]:length-1 // min. 1 wp & runway
	{
		SET nextwaypoint to route[1][flyroute_a].
		set pop_way:index to findWaypointByName(nextwaypoint[0]). // print current target waypoint as way mode parameter
		MAINTAINHEADING(flytowaypoint(nextwaypoint)).
		IF wp_distance < 4000
		{
			SET flyroute_a to flyroute_a+1.
		}
	}

	ELSE // only runway (remaining)
	{
		interface_lnd:show().
		SET runwayname to route[1][route[1]:length-1][0].
		SET lnd_param to findRunwayByName(runwayname). // pass name of the runway to the function
		SET pop_lnd:index to lnd_param.
		if b_spd:pressed { set b_spd:pressed to false.}
		if b_alt:pressed { set b_alt:pressed to false.}
		if b_pit:pressed { set b_pit:pressed to false.}
		set b_lnd:pressed to true.
	}

}

// Colours the dots on the terrain radar
function terrainRadar
{
	local terrRad_distance is 2.0.
	local terrRad_width is 2.0.
	local sensitivity is 100.	// If there is less than 100m between terrainheight and your altitude, 100% RED
	local f_sens is 0.001.//(1/sensitivity)

	local t1 is time:seconds.
	//clearscreen.
	local l is terrAlt_mainscreen_layoutlabels:widgets:length.
	local c is terrAlt_mainscreen_layoutlabels:widgets[0]:widgets:length.
	local i is 0.
	until i >= l	// lines (dotrows)
	{
		local line is terrAlt_mainscreen_layoutlabels:widgets[i].
		local dot_distance is 1 - i/(l-1).
		local j is 0.
		until j >= c
		{
			local dot_width is (0.5 - j/(c-1)) * 2.
			local r is 1 - (altitude - latlng(latitude + sin(vVelHeading) * dot_width * terrRad_width + cos(vVelHeading) * dot_distance * terrRad_distance,longitude - cos(vVelHeading) * dot_width * terrRad_width + sin(vVelHeading) * dot_distance * terrRad_distance):terrainheight - sensitivity) * f_sens. // bounds are apparently not needed for rgb input
			set line:widgets[j]:style:textcolor to rgb(r,1-r,0).
			set j to j + 1.
		}
		set i to i + 1.
	}
	//print "Radar Update Time: " + round(time:seconds - t1,5) + "s     " at (0,20).
}

function colourButton
{
	parameter b.
	parameter c.

	if c = 0	// Standard
	{
		set b:style:textcolor to rgb(0.8,0.8,0.8).
		set b:style:on:textcolor to rgb(0.1,0.9,0.1).
		set b:style:hover:textcolor to rgb(1.0,0.8,0.0).
		set b:style:hover_on:textcolor to rgb(1.0,0.8,0.0).
		set b:style:active:textcolor to rgb(0.1,0.9,0.1).
		set b:style:active_on:textcolor to rgb(0.1,0.9,0.1).
		set b:style:bg to "KK_ap/button_empty_std.png".
		set b:style:on:bg to "KK_ap/button_empty_pushed.png".
		set b:style:hover:bg to "KK_ap/button_empty_hover.png".
		set b:style:hover_on:bg to "KK_ap/button_empty_hover.png".
		set b:style:active:bg to "KK_ap/button_empty_pushed.png".
		set b:style:active_on:bg to "KK_ap/button_empty_pushed.png".
	}
	if c = 1	// Disabled
	{
		set b:style:textcolor to rgb(0.6745,0.031,0).
		set b:style:on:textcolor to rgb(0.6745,0.031,0).
		set b:style:hover:textcolor to rgb(1.0,0.8,0.0).
		set b:style:hover_on:textcolor to rgb(1.0,0.8,0.0).
		set b:style:active:textcolor to rgb(0.6745,0.031,0).
		set b:style:active_on:textcolor to rgb(0.6745,0.031,0).
		set b:style:bg to "KK_ap/button_empty_disabled.png".
		set b:style:on:bg to "KK_ap/button_empty_disabled.png".
		set b:style:hover:bg to "KK_ap/button_empty_hover.png".
		set b:style:hover_on:bg to "KK_ap/button_empty_hover.png".
		set b:style:active:bg to "KK_ap/button_empty_disabled.png".
		set b:style:active_on:bg to "KK_ap/button_empty_disabled.png".
	}
	if c = 2		// Used by another function
	{
		set b:style:textcolor to rgb(0.0392,0,0.6549).
		set b:style:on:textcolor to rgb(0.0392,0,0.6549).
		set b:style:hover:textcolor to rgb(1.0,0.8,0.0).
		set b:style:hover_on:textcolor to rgb(1.0,0.8,0.0).
		set b:style:active:textcolor to rgb(0.0392,0,0.6549).
		set b:style:active_on:textcolor to rgb(0.0392,0,0.6549).
		set b:style:bg to "KK_ap/button_empty_used.png".
		set b:style:on:bg to "KK_ap/button_empty_used.png".
		set b:style:hover:bg to "KK_ap/button_empty_hover.png".
		set b:style:hover_on:bg to "KK_ap/button_empty_hover.png".
		set b:style:active:bg to "KK_ap/button_empty_used.png".
		set b:style:active_on:bg to "KK_ap/button_empty_used.png".
	}	
}
















//-------------------------------------------------------------------------------------------------------------
//__ M A I N   L O O P __

CLEARSCREEN.

set vMaintainRoll_totalerror to 0.
set vMaintainRoll_lastFacingRollRate to 0.
set vMaintainRoll_OscCount to 0.
set vMaintainRoll_OscFrequency to 0.
set vMaintainRoll_OscDamper to 0.

SET autolAND_mode to "descend".
set landingabort to 0.
set runway_reached to 0.
set holdpitch_param to 0.
set ang_totalerror to 0.
set autoland_appr_decc to 0.
set touchdowned to 0.
set autoland_phase to "       ".
set autoland_targetmode to "wp".
set autoland_headingmode to 0.
set TO_override to false.

set lastdistance to 0.
set lastdistance_settime to 1.

set autoland_mode_maintain_tAlt to -1.
set AUTO_holdroll to false.
set AUTO_holdpitch to false.

set AUTOFLY_rollTarget to 0.
set AUTOFLY_pitchTarget to 0.
set AUTOFLY_hdgTarget to 0.
set autoland_glideslope_lastError to 0.

set wp_distance to 0.
set flyroute_a to 0.
set dist_destination to 0.001.
set flyroute_landing to false.
set interface_lnd_active to false.
set nav_lastdistance to 0.
set nav_distance_eta to 0.
set flighttime_avg to 0.
set flighttime_a to 0.
set vVelHeading to 0.


set lag to 1.

set terminal:width to 50.
set terminal:height to 36.

set route to routes[0].
set navroute to routes[0].

print "Loading Aircraft Data:".
print " ".
set datLoaded to false.
set i to 0.
until i > airplaneData:length - 1 or datLoaded = true
{
	if ship:name = airplaneData[i][0]
	{
		set height to airplanedata[i][1].
		set thrreverse to airplanedata[i][2].
		set minSpeed to airplanedata[i][3].
		set maxSpeed to airplanedata[i][4].
		set approachdec to airplanedata[i][5].
		set vTakeOffSpeed to airplanedata[i][6].
		set vTakeOffAngle to airplanedata[i][7].
		set vAfterTakeOffSpeed to airplanedata[i][8].
		set vAfterTakeOffAngle to airplanedata[i][9].

		set datLoaded to true.

		print "-- Matching Data found!".
		print "-- Loading Data for " + airplaneData[i][0] + ".".
		print " ".
	}
	else set i to i + 1.
}

if datLoaded = false
{
	print "No Matching Data found!".
}

set t_set_height:text to height:tostring().
set t_set_thrrev:text to thrreverse:tostring().
set t_set_minSpeed:text to minSpeed:tostring().
set t_set_maxSpeed:text to maxSpeed:tostring().
set t_set_apprdecc:text to approachdec:tostring().
set t_set_tospeed:text to vTakeOffSpeed:tostring().
set t_set_toangle:text to vTakeOffAngle:tostring().
set t_set_afttoangle:text to vAfterTakeOffAngle:tostring().
set t_set_afttospeed:text to vAfterTakeOffSpeed:tostring().
set t_set_appitchlimit:text to vAP_boundpitchangle:tostring().
set t_set_aprolllimit:text to vAP_boundrollangle:tostring().
set t_set_gldslopetgt:text to glideslopetarget:tostring().
set t_set_flaredistance:text to flaredistance:tostring().
set t_set_allowlndabort:text to landingabort_allow:tostring().
set t_set_maxalt:text to maxaltitude:tostring().
set t_set_geardeploy:text to geardeploydistance:tostring().

print "height = " + height.
print "thrreverse = " + thrreverse.
print "minSpeed = " + minSpeed.
print "maxSpeed = " + maxSpeed.
print "approachdec = " + approachdec.
print "vTakeOffSpeed = " + vTakeOffSpeed.
print "vTakeOffAngle = " + vTakeOffAngle.
print "vAfterTakeOffSpeed = " + vAfterTakeOffSpeed.
print "vAfterTakeOffAngle = " + vAfterTakeOffAngle.
clearscreen.



set mode_spd to false.
set mode_alt to false.
set mode_hdg to false.
set mode_pit to false.
set mode_tof to false.
set mode_lnd to false.
set mode_nav to false.
set mode_way to false.
set mode_fbw to false.

set spd_param to 0.
set alt_param to 0.
set hdg_param to 0.
set pit_param to 0.
set tof_param to 0.
set lnd_param to 0.
set nav_param to 0.
set way_param to 0.


set mode_tof_allow to true.
set mode_lnd_allow to true.
set mode_nav_doTakeoff to false.
set mode_tof_enableLaterNav to false.


set b_spd:onclick to 
{ 
	toggle mode_spd. 
	if mode_spd = false	// required because if left out, controls will be locked
	{
		set ship:control:neutralize to true.
		unlock all.
	}
}.
set t_spd:onconfirm to { parameter val. set spd_param to val:tonumber(0).}.

set b_alt:onclick to 
{ 
	toggle mode_alt. 
	if mode_alt = true
	{
		if b_pit:pressed
		{
			set b_pit:pressed to false.
		}
		if b_tof:pressed
		{
			set b_tof:pressed to false.
		}
		colourButton(b_pit,2).
		if b_lnd:pressed = true
		{
			set b_lnd:pressed to false.
		}
	}
	else	// required because if left out, controls will be locked
	{
		colourButton(b_pit,0).
		set ship:control:neutralize to true.
		unlock all.
	}
}.
set t_alt:onconfirm to { parameter val. set alt_param to val:tonumber(0).}.

set b_hdg:onclick to 
{ 
	toggle mode_hdg. 
	if mode_hdg = true
	{
		if b_tof:pressed
		{
			set b_tof:pressed to false.
		}
		if b_lnd:pressed
		{
			set b_lnd:pressed to false.
		}
		if b_nav:pressed
		{
			set b_nav:pressed to false.
		}
		if b_way:pressed
		{
			set b_way:pressed to false.
		}
	}
	else	// required because if left out, controls will be locked
	{
		set ship:control:neutralize to true.
		unlock all.
	}
}.
set t_hdg:onconfirm to { parameter val. set hdg_param to val:tonumber(0).}.

set b_pit:onclick to 
{ 
	toggle mode_pit. 
	if mode_pit = true
	{
		if b_alt:pressed
		{
			set b_alt:pressed to false.
		}
		if b_tof:pressed
		{
			set b_tof:pressed to false.
		}
		if b_lnd:pressed
		{
			set b_lnd:pressed to false.
		}
	}
	else	// required because if left out, controls will be locked
	{
		set ship:control:neutralize to true.
		unlock all.
	}
}.
set t_pit:onconfirm to { parameter val. set pit_param to val:tonumber(0).}.

set b_tof:onclick to 
{
	toggle mode_tof.
	if mode_tof = true
	{
		if CHECKTAKEOFF = false and TO_override = false
		{
			set mode_tof to false.
			set b_tof:pressed to false.
			if mode_tof_allow { HUDTEXT("<AP> No available runway found", 6, 2, 18, red, false).}
			else { HUDTEXT("<AP> Auto takeoff not available", 6, 2, 18, red, false).}
		}
		else
		{
			HUDTEXT("<AP> Takeoff from " + TO_runway[0], 6, 2, 18, yellow, false).
			set mode_tof_initAlt to altitude.
			if b_spd:pressed
			{
				set b_spd:pressed to false.
			}
			if b_alt:pressed
			{
				set b_alt:pressed to false.
			}
			if b_hdg:pressed
			{
				set b_hdg:pressed to false.
			}
			if b_pit:pressed
			{
				set b_pit:pressed to false.
			}
			if b_lnd:pressed
			{
				set b_lnd:pressed to false.
			}
			if b_way:pressed
			{
				set b_way:pressed to false.
			}
			if b_nav:pressed
			{
				set b_nav:pressed to false.
				set mode_tof_enableLaterNav to true.
			}

			// COLOUR THE USED FUNCTIONS IN GUI
			colourButton(b_spd,2).
			colourButton(b_hdg,2).
			colourButton(b_pit,2).

			set TO_override to false.	// reset for the next launch if override was used
		}
	}
	if mode_tof = false
	{
		set ship:control:neutralize to true.
		unlock all.

		set TO_pitchTarget to 0.
		if mode_tof_enableLaterNav = true
		{
			set mode_tof_enableLaterNav to false.
			colourButton(b_way,2).
			colourButton(b_hdg,2).
			colourButton(b_pit,2).
			colourButton(b_spd,2).
			colourButton(b_alt,2).
			set b_nav:pressed to true.
		}	

		// COLOUR THE USED FUNCTIONS IN GUI
		colourButton(b_spd,0).
		colourButton(b_hdg,0).
		colourButton(b_pit,0).
	}
}.

set b_lnd:onclick to 
{ 
	toggle mode_lnd. 
	if mode_lnd and mode_lnd_allow
	{
		set autoland_targetmode to "wp".
		set autoland_appr_decc to 0.
		set autoland_mode to "descend".
		set landingabort to false.
		set lnd_touchdowntime_set to false.
		set autoland_headingmode to 0.
		set autoland_abort_mode to 0.
		set runway_reached to false.
		set autoland_appr_decc to 0.

		HUDTEXT("<AP> Landing on " + runway_database[lnd_param][0], 6, 2, 18, yellow, false).
		
		if b_spd:pressed
		{
			set b_spd:pressed to false.
		}
		if b_alt:pressed
		{
			set b_alt:pressed to false.
		}
		if b_hdg:pressed
		{
			set b_hdg:pressed to false.
		}
		if b_pit:pressed
		{
			set b_pit:pressed to false.
		}
		if b_tof:pressed
		{
			set b_tof:pressed to false.
		}
		if b_way:pressed
		{
			set b_way:pressed to false.
		}
		if b_nav:pressed
		{
			set b_nav:pressed to false.
		}

		interface_lnd:show().

		// COLOUR THE USED FUNCTIONS IN GUI
		colourButton(b_spd,2).
		colourButton(b_hdg,2).
		colourButton(b_pit,2).
	}
	else if mode_lnd_allow = false
	{
		HUDTEXT("<AP> Autoland not available", 6, 2, 18, red, false).
	}
	if mode_lnd = false	// required because if left out, controls will be locked
	{
		set ship:control:neutralize to true.
		unlock all.

		// COLOUR THE USED FUNCTIONS IN GUI
		colourButton(b_spd,0).
		colourButton(b_hdg,0).
		colourButton(b_pit,0).

		interface_lnd:hide().
	}
}.
set pop_lnd:onchange to
{ 
	parameter val.
	set lnd_param to findRunwayByName(val).
	if mode_lnd { HUDTEXT("<AP> Runway changed to " + runway_database[lnd_param][0], 6, 2, 18, yellow, false).}
}.

set b_nav:onclick to 
{
	toggle mode_nav.
	if mode_nav
	{
		flyroute(routes[nav_param]).
		set nav_altitude to round( min((dist_destination / 30000 * 1500),maxAltitude) / 100)*100.	
		set alt_param to nav_altitude.
		set t_alt:text to nav_altitude:tostring().
		set nav_speed to maxSpeed.
		set b_alt:pressed to true.
		set b_spd:pressed to true.
		set spd_param to nav_speed.
		set t_spd:text to nav_speed:tostring().
		if (alt:radar - height) < 10 and airspeed < 20
		{
			set mode_nav_doTakeoff to true.
		}
		if b_hdg:pressed
		{
			set b_hdg:pressed to false.
		}
		if b_tof:pressed
		{
			set b_tof:pressed to false.
		}
		if b_way:pressed
		{
			set b_way:pressed to false.
		}
		interface_nav:show().	
		HUDTEXT("<AP> Flying route " + routes[nav_param][0], 6, 2, 18, yellow, false).
		colourButton(b_way,2).
		colourButton(b_hdg,2).
		colourButton(b_pit,2).
		colourButton(b_alt,0).
	}
	if mode_nav = false
	{
		set ship:control:neutralize to true.
		unlock all.
		interface_nav:hide().
		colourButton(b_spd,0).
		colourButton(b_hdg,0).	
		colourButton(b_pit,0).
		colourButton(b_lnd,0).
		colourButton(b_way,0).	

		set wp_distance to 0.
		set flyroute_a to 0.
		set dist_destination to 0.001.
		set flyroute_landing to false.
		set interface_lnd_active to false.
		set nav_lastdistance to 0.
		set nav_distance_eta to 0.
		set flighttime_avg to 0.
		set flighttime_a to 0.
	}
}.
set pop_nav:onchange to 
{ 
	parameter val. 
	set nav_param to findRouteByName(val).
	flyroute(routes[nav_param]).
	set nav_altitude to round( min((dist_destination / 30000 * 1500),maxAltitude) / 100)*100.	
	set alt_param to nav_altitude.
	set t_alt:text to nav_altitude:tostring().
}.

set b_way:onclick to 
{
	toggle mode_way.
	if mode_way = true
	{
		if b_hdg:pressed
		{
			set b_hdg:pressed to false.
		}
		if b_tof:pressed
		{
			set b_tof:pressed to false.
		}
		if b_nav:pressed
		{
			set b_way:pressed to false.
		}
		HUDTEXT("<AP> Flying to " + waypoint_database[way_param][0] + ", distance is " + round(waypoint_database[way_param][1]:distance/1000) + "km", 6, 2, 18, yellow, false).
		colourButton(b_hdg,2).
	}
	if mode_way = false
	{
		set ship:control:neutralize to true.
		unlock all.
		colourButton(b_hdg,0).

		set wp_distance to 0.
		set flyroute_a to 0.
		set dist_destination to 0.001.
		set flyroute_landing to false.
		set interface_lnd_active to false.
		set nav_lastdistance to 0.
		set nav_distance_eta to 0.
		set flighttime_avg to 0.
		set flighttime_a to 0.
	}
}.
set pop_way:onchange to 
{ 
	parameter val. 
	set way_param to findWaypointByName(val).
	if mode_nav = true
	{
		HUDTEXT("<AP> Flying to " + waypoint_database[way_param][0] + ", distance is " + round(waypoint_database[way_param][1]:distance/1000) + "km", 6, 2, 18, yellow, false).
	}
}.

global running is true.
global starttime is time:seconds.

until running = false
{
	local vTime0 is time:seconds.

	INPUT().
	if terrainRadar_running = true 
	{
		terrainRadar().
	}


	if mode_spd
	{
		AUTOTHROTTLE(spd_param).
	}
	if mode_alt
	{
		HOLDALTITUDE(alt_param).
	}
	if mode_hdg
	{
		MAINTAINHEADING(hdg_param).
	}
	if mode_pit
	{
		MAINTAINVP(arcsin(pit_param/60/airspeed)).
	}
	if mode_tof and mode_tof_allow
	{
		TAKEOFF().
		if alt:radar > mode_tof_initAlt  + 1000	// Needs to end itself now, activate other modes
		{
			set b_tof:pressed to false.
			set ship:control:neutralize to true.
			unlock all.
			HUDTEXT("<AP> You have control", 6, 2, 18, yellow, false).
		}
	}

	// CONDITION FOR mode_tof_allow
	if alt:radar-height < 10 and airspeed < 20 and mode_tof_allow = false or TO_override = true
	{
		set mode_tof_allow to true.
		if b_tof:style:bg <> "KK_ap/button_empty_std.png" 
		{
			colourButton(b_tof,0).
		}
	}
	else if alt:radar-height > 10 and mode_tof_allow = true and mode_tof = false and TO_override = false
	{
		set mode_tof_allow to false.
		if b_tof:style:bg <> "KK_ap/button_empty_disabled.png"
		{
			colourButton(b_tof,1).
		}
		if b_tof:pressed { set b_tof:pressed to false.}
	}


	if mode_lnd and mode_lnd_allow
	{
		AUTOLAND(lnd_param).
		set lnd_mainscreen_rnwname:text to targetrunway[0].
		set lnd_mainscreen_hdg:text to round(targetrunway[2]) + "deg".
		set lnd_mainscreen_distance:text to round(grounddistance/1000,1) + "km".
		set lnd_mainscreen_eta:text to floor(avg_eta/60) + "min " + round(mod(avg_eta,60)) + "s".
		if altitudeError > 0 { set lnd_mainscreen_alterror:text to "<b>" + "+" + round(altitudeError) + "m" + "</b>".}
		else {set lnd_mainscreen_alterror:text to "<b>" + round(altitudeError) + "m" + "</b>".}
			
			if abs(altitudeError) >= 500
			{
				set lnd_mainscreen_staticalterror:style:textcolor to rgb(0.9,0,0).
				set lnd_mainscreen_alterror:style:textcolor to rgb(0.9,0,0).
			}
			else if abs(altitudeError) < 500 and abs(altitudeError) >= 50
			{
				set lnd_mainscreen_staticalterror:style:textcolor to rgb(1.0,0.8,0.0).
				set lnd_mainscreen_alterror:style:textcolor to rgb(1.0,0.8,0.0).
			}
			else if abs(altitudeError) < 50
			{
				set lnd_mainscreen_staticalterror:style:textcolor to rgb(0.1,0.9,0.1).
				set lnd_mainscreen_alterror:style:textcolor to rgb(0.1,0.9,0.1).
			}

		SET lnd_hdgerror to headingtarget - vVelHeading.
		if lnd_hdgerror > 180
		{
			set lnd_hdgerror to lnd_hdgerror - 360.
		}
		else if lnd_hdgerror < -180
		{
			set lnd_hdgerror to lnd_hdgerror + 360.
		}
		if lnd_hdgerror > 0 { set lnd_mainscreen_hdgerror:text to "<b>" + "+" + round(lnd_hdgerror,1) + "deg" + "</b>".}
		else {set lnd_mainscreen_hdgerror:text to "<b>" + round(lnd_hdgerror,1) + "deg" + "</b>".}

			if abs(lnd_hdgerror) >= 10
			{
				set lnd_mainscreen_statichdgerror:style:textcolor to rgb(0.9,0,0).
				set lnd_mainscreen_hdgerror:style:textcolor to rgb(0.9,0,0).
			}
			else if abs(lnd_hdgerror) < 10 and abs(lnd_hdgerror) >= 2
			{
				set lnd_mainscreen_statichdgerror:style:textcolor to rgb(1.0,0.8,0.0).
				set lnd_mainscreen_hdgerror:style:textcolor to rgb(1.0,0.8,0.0).
			}
			else if abs(lnd_hdgerror) < 2
			{
				set lnd_mainscreen_statichdgerror:style:textcolor to rgb(0.1,0.9,0.1).
				set lnd_mainscreen_hdgerror:style:textcolor to rgb(0.1,0.9,0.1).
			}

		set lnd_mainscreen_vs:text to round(verticalspeed,1) + "m/s".
		if airspeed <= 5
		{
			set b_lnd:pressed to false.
			set ship:control:neutralize to true.
			unlock all.
		}
	}

	// CONDITION FOR mode_lnd_allow
	if alt:radar-height > 100 and mode_lnd_allow = false and mode_tof = false
	{
		set mode_lnd_allow to true.
		if b_lnd:style:bg <> "KK_ap/button_empty_std.png" 
		{
			colourButton(b_lnd,0).
		}
	}
	else if alt:radar-height < 100 and mode_lnd_allow = true and mode_lnd = false or mode_tof = true and mode_lnd_allow = true
	{
		set mode_lnd_allow to false.
		if b_lnd:style:bg <> "KK_ap/button_empty_disabled.png"
		{
			colourButton(b_lnd,1).
		}
		if b_lnd:pressed { set b_lnd:pressed to false.}
	}

	if mode_nav
	{
		set nav_mainscreen_routestart:text to navroute[0].
		set nav_mainscreen_distance:text to round(dist_destination/1000):tostring() + "km".
		local time1 is dist_destination / airspeed.
		if nav_distance_eta < 0
		{
			set flighttime to time1.	// raw distance / airspeed calculation
		}
		else
		{
			set flighttime to (time1 + nav_distance_eta) / 2.	// avg of time1, rate of change of distance based eta
		}
		local h is floor(flighttime/3600).
		local min is floor(flighttime/60-h*60).
		local s is flighttime-h*3600-min*60.
		set nav_mainscreen_time:text to h + "h " + min + "min " + round(s) + "s".
		flyroute(routes[nav_param]).
	}

	if mode_way
	{
		MAINTAINHEADING(flytowaypoint(waypoint_database[way_param])).
	}

	set lag to time:seconds - vTime0.
	print "lag: " + round(lag,3) + "s  " at (35,0).
}

clearguis().
set ship:control:neutralize to true.
unlock all.

